﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace CheckBoxListTester
{
    public partial class CheckBoxTextBox : UserControl
    {
        public CheckBoxTextBox()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Any of the underlying properties of the controls on the UserControl should be made available
        /// as below which access the underlying properties
        /// </summary>
        public override string Text
        {
            get
            {
                return this.textBox1.Text;
            }
            set
            {
                this.textBox1.Text = value;

                this.Height = MeasureString(CreateGraphics(), this.textBox1.Text, this.ClientRectangle, true).Height;
            }
        }

        /// <summary>
        /// Any of the underlying properties of the controls on the UserControl should be made available
        /// as below which access the underlying properties
        /// </summary>
        public virtual bool Checked
        {
            get
            {
                return this.checkBox1.Checked;
            }
            set
            {
                this.checkBox1.Checked = value;
            }
        }

        private struct Rect 
        { 
            public int Left, Top, Right, Bottom; 
            
            public Rect(Rectangle r) 
            { 
                this.Left = r.Left; 
                this.Top = r.Top; 
                this.Bottom = r.Bottom; 
                this.Right = r.Right; 
            } 
        }

        [DllImport("coredll.dll")]
        static extern int DrawText(IntPtr hdc, string lpStr, int nCount, ref Rect lpRect, int wFormat); 
        
        private const int DT_CALCRECT = 0x00000400; 
        private const int DT_WORDBREAK = 0x00000010; 
        private const int DT_EDITCONTROL = 0x00002000; 
        
        /// <summary>
        /// http://www.mobilepractices.com/2007/12/multi-line-graphicsmeasurestring.html
        /// </summary>
        /// <param name="gr"></param>
        /// <param name="text"></param>
        /// <param name="rect"></param>
        /// <param name="textboxControl"></param>
        /// <returns></returns>
        public Size MeasureString(Graphics gr, string text, Rectangle rect, bool textboxControl) 
        { 
            Rect bounds = new Rect(rect); 
            IntPtr hdc = gr.GetHdc(); 
            int flags = DT_CALCRECT | DT_WORDBREAK; 
            if (textboxControl) flags |= DT_EDITCONTROL; 
            DrawText(hdc, text, text.Length, ref bounds, flags); 
            gr.ReleaseHdc(hdc); 
            return new Size(bounds.Right - bounds.Left, bounds.Bottom - bounds.Top + (textboxControl ? 10 : 4)); 
        }
    }
}
